/********************************************************************
 * Copyright (c) 2021 by SK karoly.saly@matrasoft.hu				*
 *																	*
 * s7com32 - s7com32res.h											*
 ********************************************************************/
#ifndef _INC_S7COM32RES
#define _INC_S7COM32RES

#define S7ERR_NONE						0
#define S7ERR_NOMEMORY					1
#define S7ERR_INVALIDMODE				2
#define S7ERR_INTERFACEINUSE			3
#define S7ERR_LIBCANTOPEN				4
#define S7ERR_LIBERROR					5
#define S7ERR_INVALIDINTERFACE			6
#define S7ERR_INVALIDCONNECTION			7
#define S7ERR_DISCONNECTED				8
#define S7ERR_SCPERROR					9
#define S7ERR_SOCKETERROR				10
#define S7ERR_UNKNOWNPDU				11
#define S7ERR_PDUERROR					12
#define S7ERR_INVALIDPDUSIZE			13
#define S7ERR_TIMEOUT					14
#define S7ERR_INVALIDRESPONSE			15
#define S7ERR_REJECTEDRESPONSE			16
#define S7ERR_INVALIDTYPE				17
#define S7ERR_INVALIDAREA				18
#define S7ERR_INVALIDADDRESS			19
#define S7ERR_INVALIDCOUNT				20
#define S7ERR_TOOMUCHITEM				21
#define S7ERR_TOOBIGSIZE				22
#define S7ERR_INVALIDDATE				23
#define S7ERR_INVALIDREQUEST			24
#define S7ERR_NOITEM					25
#define S7ERR_PARERROR					26
#define S7ERR_DATERROR					27
#define S7ERR_BADDATSIZE				28
#define S7ERR_BADREPLYSIZE				29

#ifndef IDS_S7ERR_BASE
#define IDS_S7ERR_BASE					10000
#endif

#define IDS_S7ERR_NOMEMORY				(IDS_S7ERR_BASE + S7ERR_NOMEMORY)
#define IDS_S7ERR_INVALIDMODE			(IDS_S7ERR_BASE + S7ERR_INVALIDMODE)
#define IDS_S7ERR_INTERFACEINUSE		(IDS_S7ERR_BASE + S7ERR_INTERFACEINUSE)
#define IDS_S7ERR_LIBCANTOPEN			(IDS_S7ERR_BASE + S7ERR_LIBCANTOPEN)
#define IDS_S7ERR_LIBERROR				(IDS_S7ERR_BASE + S7ERR_LIBERROR)
#define IDS_S7ERR_INVALIDINTERFACE		(IDS_S7ERR_BASE + S7ERR_INVALIDINTERFACE)
#define IDS_S7ERR_INVALIDCONNECTION		(IDS_S7ERR_BASE + S7ERR_INVALIDCONNECTION)
#define IDS_S7ERR_DISCONNECTED			(IDS_S7ERR_BASE + S7ERR_DISCONNECTED)
#define IDS_S7ERR_SCPERROR				(IDS_S7ERR_BASE + S7ERR_SCPERROR)
#define IDS_S7ERR_SOCKETERROR			(IDS_S7ERR_BASE + S7ERR_SOCKETERROR)
#define IDS_S7ERR_UNKNOWNPDU			(IDS_S7ERR_BASE + 1S7ERR_UNKNOWNPDU)
#define IDS_S7ERR_PDUERROR				(IDS_S7ERR_BASE + S7ERR_PDUERROR)
#define IDS_S7ERR_INVALIDPDUSIZE		(IDS_S7ERR_BASE + S7ERR_INVALIDPDUSIZE)
#define IDS_S7ERR_TIMEOUT				(IDS_S7ERR_BASE + S7ERR_TIMEOUT)
#define IDS_S7ERR_INVALIDRESPONSE		(IDS_S7ERR_BASE + S7ERR_INVALIDRESPONSE)
#define IDS_S7ERR_REJECTEDRESPONSE		(IDS_S7ERR_BASE + S7ERR_REJECTEDRESPONSE)
#define IDS_S7ERR_INVALIDTYPE			(IDS_S7ERR_BASE + S7ERR_INVALIDTYPE)
#define IDS_S7ERR_INVALIDAREA			(IDS_S7ERR_BASE + S7ERR_INVALIDAREA)
#define IDS_S7ERR_INVALIDADDRESS		(IDS_S7ERR_BASE + S7ERR_INVALIDADDRESS)
#define IDS_S7ERR_INVALIDCOUNT			(IDS_S7ERR_BASE + S7ERR_INVALIDCOUNT)
#define IDS_S7ERR_TOOMUCHITEM			(IDS_S7ERR_BASE + S7ERR_TOOMUCHITEM)
#define IDS_S7ERR_TOOBIGSIZE			(IDS_S7ERR_BASE + S7ERR_TOOBIGSIZE)
#define IDS_S7ERR_INVALIDDATE			(IDS_S7ERR_BASE + S7ERR_INVALIDDATE)
#define IDS_S7ERR_INVALIDREQUEST		(IDS_S7ERR_BASE + S7ERR_INVALIDREQUEST)
#define IDS_S7ERR_NOITEM				(IDS_S7ERR_BASE + S7ERR_NOITEM)
#define IDS_S7ERR_PARERROR				(IDS_S7ERR_BASE + S7ERR_PARERROR)
#define IDS_S7ERR_DATERROR				(IDS_S7ERR_BASE + S7ERR_DATERROR)
#define IDS_S7ERR_BADDATSIZE			(IDS_S7ERR_BASE + S7ERR_BADDATSIZE)
#define IDS_S7ERR_BADREPLYSIZE			(IDS_S7ERR_BASE + S7ERR_BADREPLYSIZE)

#endif  // _INC_S7COM32RES
